POJ_3463_Sightseeing(最短路/次短路条数)

Sightseeing

Time Limit: 2000MS   Memory Limit: 65536K
Total Submissions: 7421   Accepted: 2659

Description

Tour operator Your Personal Holiday organises guided bus trips across the Benelux. Every day the bus moves from one city
S to another city F. On this way, the tourists in the bus can see the sights alongside the route travelled. Moreover, the bus makes a number of stops (zero or more) at some beautiful cities, where the tourists get out to see the local sights.

Different groups of tourists may have different preferences for the sights they want to see, and thus for the route to be taken from
S to F. Therefore, Your Personal Holiday wants to offer its clients a choice from many different routes. As hotels have been booked in advance, the starting city
S and the final city F, though, are fixed. Two routes from
S
to F are considered different if there is at least one road from a city
A to a city B which is part of one route, but not of the other route.

There is a restriction on the routes that the tourists may choose from. To leave enough time for the sightseeing at the stops (and to avoid using too much fuel), the bus has to take a short route from
S to F. It has to be either a route with minimal distance, or a route which is one distance unit longer than the minimal distance. Indeed, by allowing routes that are one distance unit longer, the tourists may have more choice than by restricting
them to exactly the minimal routes. This enhances the impression of a personal holiday.

For example, for the above road map, there are two minimal routes from S = 1 to
F = 5: 1 → 2 → 5 and 1 → 3 → 5, both of length 6. There is one route that is one distance unit longer: 1 → 3 → 4 → 5, of length 7.

Now, given a (partial) road map of the Benelux and two cities S and
F
, tour operator Your Personal Holiday likes to know how many different routes it can offer to its clients, under the above restriction on the route length.

Input

The first line of the input file contains a single number: the number of test cases to follow. Each test case has the following format:

  • One line with two integers N and M, separated by a single space, with 2 ≤
    N ≤ 1,000 and 1 ≤ M ≤ 10, 000: the number of cities and the number of roads in the road map.
  • M lines, each with three integers A, B and L, separated by single spaces, with 1 ≤
    A, BN, AB and 1 ≤ L ≤ 1,000, describing a road from city
    A to city B with length L.

    The roads are unidirectional. Hence, if there is a road from A to
    B
    , then there is not necessarily also a road from B to A. There may be different roads from a city
    A to a city B.

  • One line with two integers S and F, separated by a single space, with 1 ≤
    S, FN and SF: the starting city and the final city of the route.

    There will be at least one route from S to F.

Output

For every test case in the input file, the output should contain a single number, on a single line: the number of routes of minimal length or one distance unit longer. Test cases are such, that this number is at most 109 = 1,000,000,000.

Sample Input

2
5 8
1 2 3
1 3 2
1 4 5
2 3 1
2 5 3
3 4 2
3 5 4
4 5 3
1 5
5 6
2 3 1
3 2 1
3 1 10
4 5 2
5 2 7
5 2 7
4 1

Sample Output

3
2

Hint

The first test case above corresponds to the picture in the problem description.

题意:给你一个有向图,如果次短路长度刚好比最短路大1,那么输出最短路条数与次短路条数之和,否者直接输出最短路的条数。

分析:模板题。代码有注释哟~~~

题目链接:http://poj.org/problem?id=3463

代码清单:

#include<map>
#include<queue>
#include<stack>
#include<ctime>
#include<cctype>
#include<cstdio>
#include<cstring>
#include<string>
#include<iostream>
#include<algorithm>
using namespace std;
typedef long long ll;
const int maxn = 1000 + 5;
const int max_dis = 1e9;

struct Edge{
    int to;
    int dis;
    Edge(int to,int dis){
        this -> to = to;
        this -> dis = dis;
    }
};

struct Node{
    int d;
    int v;
    int pose;
    friend bool operator<(Node x,Node y){
        if(x.d==y.d) return x.v>y.v;
        return x.d>y.d;
    }
};

int T,N,M;
int a,b,c,S,F;
bool vis[maxn][2];
int dist[maxn][2];
int degree[maxn][2];
vector<Edge>G[maxn];

void dij(int s,int e){

    for(int i=0;i<maxn;i++){
        dist[i][0]=dist[i][1]=max_dis;
        degree[i][0]=degree[i][1]=0;
        vis[i][0]=vis[i][1]=false;
    }
    priority_queue<Node>q;
    while(q.size()) q.pop();
    Node p,w;
    p.d=0; p.v=s; p.pose=0;
    degree[p.v][p.pose]=1;
    q.push(p);
    while(q.size()){
        p=q.top(); q.pop();
        if(vis[p.v][p.pose]) continue;
        vis[p.v][p.pose]=true;
        for(int i=0;i<G[p.v].size();i++){

            Edge& e=G[p.v][i];
            if(!vis[e.to][0]&&p.d+e.dis<dist[e.to][0]){  //找到一条比当前最短路更短的路
                if(dist[e.to][0]!=max_dis){              //作为次短路,入队
                    w.v=e.to; w.d=dist[e.to][0]; w.pose=1;
                    dist[e.to][1]=dist[e.to][0];
                    degree[e.to][1]=degree[e.to][0];
                    q.push(w);
                }
                w.v=e.to; w.d=p.d+e.dis; w.pose=0;       //更新最短路,入队
                dist[e.to][0]=w.d; degree[e.to][0]=degree[p.v][p.pose];
                q.push(w);
            }

            else if(!vis[e.to][0]&&p.d+e.dis==dist[e.to][0]){ //找到一条相同距离的最短路,更新条数,不入队
                degree[e.to][0]+=degree[p.v][p.pose];
            }

            else if(!vis[e.to][1]&&p.d+e.dis<dist[e.to][1]){ //找到一条比当前次短路更短的路,不可以更新最短路,可更新次短路,入队
                w.v=e.to; w.d=p.d+e.dis; w.pose=1;
                dist[e.to][1]=w.d; degree[e.to][1]=degree[p.v][p.pose];
                q.push(w);
            }

            else if(!vis[e.to][1]&&p.d+e.dis==dist[e.to][1]){ //找到一条相同距离的次短路,更新条数,不入队
                degree[e.to][1]+=degree[p.v][p.pose];
            }
        }
    }
}

int main(){
    scanf("%d",&T);
    while(T--){
        for(int i=0;i<maxn;i++) G[i].clear();
        scanf("%d%d",&N,&M);
        for(int i=0;i<M;i++){
            scanf("%d%d%d",&a,&b,&c);
            G[a].push_back(Edge(b,c));
        }
        scanf("%d%d",&S,&F);
        dij(S,F);
        if(dist[F][0]+1==dist[F][1])
            printf("%d\n",degree[F][0]+degree[F][1]);
        else
            printf("%d\n",degree[F][0]);
    }return 0;
}
时间: 2024-08-13 15:11:04

POJ_3463_Sightseeing(最短路/次短路条数)的相关文章

HDU1688 Sightseeing(SPFA 求最短路与次短路的路径条数)可用作模板

Sightseeing Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 718    Accepted Submission(s): 293 Problem Description Tour operator Your Personal Holiday organises guided bus trips across the Bene

HDU 3191 次短路长度和条数

http://www.cnblogs.com/wally/archive/2013/04/16/3024490.html http://blog.csdn.net/me4546/article/details/6584448 维护最短路长度d[i][0]和次短路d[i][1],最短路条数dp[i][0]和次短路dp[i][1] #include <iostream> #include <string> #include <cstring> #include <cs

hdu 1688 Sightseeing【最短路,次短路条数】

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1688 题意:求最短路和次短路条数如果次短路长度=最短路长度+1 这输出次短路条数+最短路条数,否则输出最短路条数 分析:这是到模版题,献上模版: #include<stdio.h> #include<string.h> #include<algorithm> #include<iostream> #include<queue> #include<

eoj1818 dijkstra求最短路及其条数

求出有n(1 < n <= 100)个结点有向图中,结点1到结点n的最短路径,以及最短路径的条数. Input 第一行有2个整数n和m( 0 < m < 3000),接下来m行每行有三个整数u,v,w结点u到v之间有一条权为w的边(w<100000). Output 输出只有一行,为结点1到结点n之间的最短路径及其条数(用空格隔开),如果1到n之间不存在路径,输出 -1 0. Sample Input 3 3 1 2 10 2 3 15 1 3 25 Sample Outpu

PKU 3613 Cow Relays (指定路径条数的最短路)

题意:N,T,S,E:给你T条边,每条边两端都有编号和权值,问从S走到E允许走N条边,求最短路. foyld加矩阵快速幂思想. 注意要把边离散 #include <iostream> #include <fstream> #include <string.h> #include <algorithm> using namespace std; #define M 303 #define inf 0x3fffffff struct node { int a[M

HDU 3191How Many Paths Are There(TOPE排序 求次短路及条数)

How Many Paths Are There Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1266    Accepted Submission(s): 437 Problem Description oooccc1 is a Software Engineer who has to ride to the work place

HDU 1688 Sightseeing 【输出最短路+次短路条数】

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1688 题目大意:给n个点,m条有向边.再给出起点s, 终点t.求出s到t的最短路条数+次短路条数. 思路: 1.最短路和次短路是紧密相连的,在最短路松弛操作中,当我们找到一条更短的路径,也就意味着之前的路径不再是最短路,而成为了次短路,利用这个关系可以实现状态的转移. 2.好久没写优先队列了,都忘记了加个 priority_queue, 这样才能写重载,才能排序. 注释在代码里: 1 #includ

poj 3463 Sightseeing(最短路+次短路)

http://poj.org/problem?id=3463 大致题意:给出一个有向图,从起点到终点求出最短路和次短路的条数之和. 解法: 用到的数组:dis[i][0]:i到起点的最短路,dis[i][1]:i到起点的严格次短路 vis[i][0],vis[i][1]:同一维的vis数组,标记距离是否已确定 sum[i][0]:i到起点的最短路条数,sum[i][1]:i到起点的次短路条数 同一维dijkstra,内循环先找出最短的距离(次短路或最短路)d,然后枚举与该点相连的点: if(d

POJ 3463 Sightseeing (最短路 次短路)

Tour operator Your Personal Holiday organises guided bus trips across the Benelux. Every day the bus moves from one city S to another city F. On this way, the tourists in the bus can see the sights alongside the route travelled. Moreover, the bus mak